Hi there,

Thank you for opening an issue. Please note that we try to keep the Terraform issue tracker reserved for bug reports and feature requests. For general usage questions, please see: https://www.terraform.io/community.html.

If this is a bug report (for when something is there, but doesn't work how it should), please use the [bug issue template](https://github.com/terraform-providers/terraform-provider-google/issues/new?template=bug.md) instead.

If this is an enhancement / feature request (for when something (a resource, field, etc.) is missing, and should be added), please use the [enhancement template](https://github.com/terraform-providers/terraform-provider-google/issues/new?template=enhancement.md) instead.

If you have a support request or question, please check out the other resources listed [here](https://github.com/terraform-providers/terraform-provider-google/issues/new?template=question.md).

If your issue does not fit into one of the above templates, please fill out the following:

<!--- Please keep this note for the community --->

### Community Note

* Please vote on this issue by adding a 👍 [reaction](https://blog.github.com/2016-03-10-add-reactions-to-pull-requests-issues-and-comments/) to the original issue to help the community and maintainers prioritize this request
* Please do not leave "+1" or "me too" comments, they generate extra noise for issue followers and do not help prioritize the request
* If you are interested in working on this issue or have submitted a pull request, please leave a comment
* If an issue is assigned to the "modular-magician" user, it is either in the process of being autogenerated, or is planned to be autogenerated soon. If an issue is assigned to a user, that user is claiming responsibility for the issue. If an issue is assigned to "hashibot", a community member has claimed the issue already.

<!--- Thank you for keeping this note for the community --->

### Terraform Version
<!--- Please run `terraform -v` to show the Terraform core version and provider version(s). If you are not running the latest version of Terraform or the provider, please upgrade because your issue may have already been fixed. [Terraform documentation on provider versioning](https://www.terraform.io/docs/configuration/providers.html#provider-versions). --->

### Affected Resource(s)
<!--- Please list the affected resources and data sources. --->

* google_XXXXX

### Terraform Configuration Files (if applicable)
<!--- Information about code formatting: https://help.github.com/articles/basic-writing-and-formatting-syntax/#quoting-code --->

```tf
# Copy-paste your Terraform configurations here - for large Terraform configs,
# please use a service like Dropbox and share a link to the ZIP file. For
# security, you can also encrypt the files using our GPG public key: https://www.hashicorp.com/security
# If reproducing the bug involves modifying the config file (e.g., apply a config,
# change a value, apply the config again, see the bug) then please include both the
# version of the config before the change, and the version of the config after the change.
```

### Issue Description
<!---
Please explain your issue here: what you expected to happen, what actually happened, what steps did you take, etc. The more detail you're able to provide, the better we'll be able to help you.
If your issue appears when running Terraform, please provide a link to a GitHub Gist containing the complete debug output. Please do NOT paste the debug output in the issue; just paste a link to the Gist.
--->

### Important Factoids
<!--- Are there anything atypical about your accounts that we should know? For example: authenticating as a user instead of a service account? --->

### References
<!---
Information about referencing Github Issues: https://help.github.com/articles/basic-writing-and-formatting-syntax/#referencing-issues-and-pull-requests

Are there any other GitHub issues (open or closed) or pull requests that should be linked here? Vendor documentation? For example:
--->
* #0000
